# Dialogs.py
# Name: Alex Cappiello
# AndrewID: acappiel
# Section: H
# Term project for 15-110, spring 2011
# All code original work unless otherwise noted

import tkSimpleDialog, tkMessageBox
from Tkinter import *
from PIL.Image import NEAREST, ANTIALIAS, BICUBIC, BILINEAR

class Resize(tkSimpleDialog.Dialog):

    #__init__() and buttonbox() borrowed (and slightly modified) from
    #http://effbot.org/tkinterbook/tkinter-dialog-windows.htm
    #they provide a little more flexibility than the standard functions
    def __init__( self, parent, width, height, title = None, new = True,
                  resize = False):
        self.width = width; self.height = height
        self.new = new; self.resize = resize
        Toplevel.__init__( self, parent )
        self.transient( parent )
        if title:
            self.title( title )
        self.parent = parent
        self.result = None
        body = Frame (self )
        self.initial_focus = self.body( body )
        body.pack( padx = 5, pady = 5 )
        self.buttonbox()
        if not self.initial_focus:
            self.initial_focus = self
        self.protocol( "WM_DELETE_WINDOW", self.cancel )
        self.geometry( "+%d+%d" % ( parent.winfo_rootx() + 50,
                                    parent.winfo_rooty() + 50 ) )
        self.initial_focus.focus_set()
        self.wait_window( self )

    def buttonbox( self ):
        # add standard button box. override if you don't want the
        # standard buttons
        box = Frame( self )
        w = Button( box, text = "OK", width = 10, command = self.ok,
                    default = ACTIVE )
        w.pack( side = LEFT, padx = 5, pady = 5 )
        w = Button( box, text = "Cancel", width = 10, command = self.cancel )
        w.pack( side = LEFT, padx = 5, pady = 5 )
        self.bind( "<Return>", self.ok )
        self.bind( "<Escape>", self.cancel )
        box.pack()

    def resizeOptions( self, top ):
        #select which resize algorithm if applicable
        options = [ [ "Nearest", NEAREST, 2, 0 ],
                    [ "Antialias", ANTIALIAS, 2, 1 ],
                    [ "Bilinear", BILINEAR, 3, 0 ],
                    [ "Bicubic", BICUBIC, 3, 1 ] ]
        self.resizeFilter = StringVar()
        self.resizeFilter.set( BICUBIC )
        for filter_ in options:
            tmp = Radiobutton( top, text = filter_[ 0 ],
                               variable = self.resizeFilter,
                               value = filter_[ 1 ] )
            tmp.grid( row = filter_[ 2 ], column = filter_[ 3 ] )
        

    def anchorOptions( self, top ):
        #select anchor, if applicable
        options = [ [ "NW", 2, 0 ], [ "N", 2, 1 ], [ "NE", 2, 2 ],
                    [ "W",  3, 0 ], [ "C", 3, 1 ], [ "E",  3, 2 ],
                    [ "SW", 4, 0 ], [ "S", 4, 1 ], [ "SE", 4, 2 ] ]
        self.anchor = StringVar()
        self.anchor.set( "C" )
        for anchor in options:
            tmp = Radiobutton( top, text = anchor[ 0 ], variable = self.anchor,
                               value = anchor[ 0 ] )
            tmp.grid( row = anchor[ 1 ], column = anchor[ 2 ] )

    def body( self, top, new = False ):
        #create all buttons
        self.success = False
        Label( top, text = "Width (pixels):" ).grid( row = 0, sticky = W )
        Label( top, text = "Height (pixels):" ).grid( row = 1, sticky = W )
        self.widthPrompt = Entry( top )
        self.heightPrompt = Entry( top )
        self.widthPrompt.grid( row = 0, column = 1 )
        self.heightPrompt.grid( row = 1, column =1 )
        self.widthPrompt.insert( 0, self.width )
        self.heightPrompt.insert( 0, self.height )
        if ( not self.new ):
            self.anchorOptions( top )
        if ( self.resize ):
            self.resizeOptions( top )

    def validate( self ):
        #make sure input is valid
        #entry does not have a number only option
        try:
            width = int( self.widthPrompt.get() )
            height = int( self.heightPrompt.get() )
            assert( width > 0 and height > 0 )
            return True
        except ( ValueError, AssertionError ):
            tkMessageBox.showerror( "Invalid", "Posive integers, please!" )
            return False

    def apply(self):
        self.width = int( self.widthPrompt.get() )
        self.height = int( self.heightPrompt.get() )
        self.success = True


